<?php

class NetworksectionModel {
  public $network_id = null;
  public $name = null;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  
  public static function find($data) {
    
  }
  
  public static function create(Array $data) {
    $model = new Networksection();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("Networksection", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Networksection($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("Networksection", "*");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Networksection($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("Networksection", "*", "$where ORDER BY network_id, name");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Networksection($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("Networksection", "*", "$where ORDER BY network_id, name");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Networksection($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";

    //var_dump($filter);exit;
    if(array_key_exists("network_id", $filter)) {
      $networkid = $filter['network_id'];
      if(is_numeric($networkid)) {
        $where .= " AND network_id=$networkid";
      }
    }
    
    if(array_key_exists("name", $filter)) {
      $name = FronkDB::singleton()->escape($filter['name']);
      if($name) {
        $where .= " AND name='$name'";
      }
    }
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}